import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.*;
import java.util.*;

public class SpriteBasicaCanvas extends GameCanvas implements Runnable {

	/* Nmero de posies que o balde pode ter no ecr	*/
	private static final int NUM_POSIES = 20;

	/* Velocidade a que a bola se desloca				*/
	private static final int VELOCIDADE = 8;

	/* A velocidade a que o balde se desloca de cada vez que
		o utilizador pressiona uma tecla
	*/
	private int velocidadeBalde;

	/* A posio do balde						*/
	private int baldeX = 0;

	/**//* As sprites para o balde e para a bola	*/
	private Sprite balde;
	private Sprite bola;/**/

	Random random = new Random();

	/* A thread do motor do jogo				*/
	private Thread motor;
	/* A thread executa enquanto ligado == true	*/
	private boolean ligado = true;

	public SpriteBasicaCanvas() {
		super(false);

		/* criar as sprites	*/
		try {
			/**/Image baldeImg = Image.createImage("/balde.png");
			balde = new Sprite(baldeImg, 40, 44);

			Image bolaImg = Image.createImage("/drops.png");
			bola = new Sprite(bolaImg, 20, 20);/**/

		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}

		/* calcular a velocidade do balde 	*/
		velocidadeBalde = getWidth()/NUM_POSIES;

		/* iniciar o motor do jogo			*/
		motor = new Thread(this);
		motor.start();
	}

	public void run() {
		int largura = getWidth();

		Graphics g = getGraphics();

		/**//* inicializar a posio da primeira bola	*/
		bola.setPosition(aleatrio(largura), 0);/**/

		while (ligado) {

			/* determinar a tecla pressionada		*/
			int keyStates = getKeyStates();

			if ((keyStates & RIGHT_PRESSED) != 0) {
				baldeX += velocidadeBalde;
			} else if ((keyStates & LEFT_PRESSED) != 0) {
				baldeX -= velocidadeBalde;
			}

			/* limpar o fundo (pintar a branco)		*/
			g.setColor(255, 255, 255);
			g.fillRect(0, 0, getWidth(), getHeight());

			/**//* actualizar posio do balde e desenh-lo	*/
			balde.setPosition(baldeX, getHeight()-44);
			balde.paint(g);/**/

			/**//* actualizar a bola					*/
			bola.move(0, VELOCIDADE);
			bola.nextFrame();
			bola.paint(g);/**/

			/**//* se a bola chegou ao fundo do ecr
			   volta a coloc-la no topo				*/
			if (bola.getY() > getHeight()) {
				bola.setPosition(aleatrio(largura), 0);
			}/**/

			flushGraphics();

			try {
				Thread.sleep(100);
			} catch(InterruptedException ie) {
				System.err.println(ie.getMessage());
			}

		}
	}

	private int aleatrio(int mximo) {
		int r = Math.abs(random.nextInt()) % mximo;
		return r;
	}

	public void parar() {
		ligado = false;
		try {
			motor.join();
		} catch (InterruptedException ie) {
			System.err.println(ie.getMessage());
		}
	}
}